setInfos(6, "Beggar-my-neighbour", "Strip Jack Naked or Beggar my Neighbour", "NIFOC99", "v0.2", 0x1E8449, "en", ["game"])

def Title = "<h1 style='font-size:140%;'>Strip Jack Naked</h1>\n\n"
show(null)
setImage("StripJackNaked/StripJackNaked003.jpg")
show(Title+"or Beggar-my-neighbour")
wait(2.0)

def Nb = 26
def Np = 26
def Mb = 0
def Mp = 0
def Ms = 0
def Cb = []
def Cp = []
def Cs = []
def DeckName = loadString("StripJackNaked.DeckName")?: "StandardDeck1"

def Penalty
def Paid = false
def NoStack = true
def Player = false
def Play = true

//Closures (functions)######################################################################

def ShowRules = {//rules--------------------------------------------------------------------
	setImage(null)
	show(Title+"The game was probably invented in Britain and has been known there since "+
		"at least the 1840s.\n\nIt appears in Charles Dickens's 1861 novel Great Expectations, "+
		"as the only card game Pip, the book's protagonist, knew how to play as a child.")
	showButton("next")
	show(Title+"A standard 52-card deck is dealt face-down between two players. Your opponent, "+
		"called the bank, plays a card face-up to start a central stack, and you play "+
		"cards alternating with the bank as long as no Ace or court card (King, Queen, or "+
		"Jack) appears. These cards are <em>penalty cards.</em>\n\nIf a player turns up "+
		"such a card, their opponent has to pay a penalty: four cards for an Ace, three "+
		"for a King, two for a Queen, or one for a Jack. They play the required number of "+
		"cards onto the central pile. If all the penalty cards are numerals, the player of "+
		"the penalty card wins the hand. However, if the second player turns up another "+
		"Ace or court card, their payment ceases and the other player must pay the new "+
		"penalty. Penalties may alternate many times before one is paid fully.")
		showButton("next")
	show(Title+"Once a penalty is paid, the winner takes all the cards in the pile and "+
		"places them under their pack and the game continues. The winner has the advantage "+
		"of restarting play. When a single player has all of the cards, they have won.")
	showButton("OK")
}

def ChooseDeck = {//------------------------------------------------------------------------
	def DeckNames = []
	setImage("Bcards/"+DeckName+"/"+getRandom(52)+".png")
	if(getBoolean(Title+"Current deck is "+DeckName, "select new deck", "cancel")){		
		new File(getDataFolder().replaceAll("\\\\", "/")+"images/Bcards/").eachFile() {file->
			if(file.isDirectory()) {DeckNames << file.getName()}
		}
		def i=0
		while(i<DeckNames.size){
			setImage("Bcards/"+DeckNames[i]+"/"+getRandom(52)+".png")
			if(getBoolean(Title+DeckNames[i], "select deck", "next ->")){
				DeckName = DeckNames[i]
				save("Baccarat.DeckName", DeckName)
				i = DeckNames.size
			}else{
				i++
				if(i==DeckNames.size)i = 0
			}
		}
	}
	setImage(null)
}

def SuffleDeal = {//------------------------------------------------------------------------
	for(def j=0; j<52; j++){
		Cb[j] = j+52
	}
	Collections.shuffle(Cb)
	for(def j=26; j<52; j++){
		Cp[j-26] = Cb[j]
		Cb[j] = -1
		Cp[j] = -1
	}
}

def showCards= {Dp, Ds, Db -> //Display card images-----------------------------------------
	show(Title+"Player has "+(Np-Mp)+" cards\nBank has "+(Nb-Mb)+" cards\nStack is "+
		(Ms+1)+" cards")
	def width = 650
	def height = 500
	def image = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def graphics = image.getGraphics()
	def thisImage 
	thisImage = javax.imageio.ImageIO.read(new File("images/StripJackNaked/StripJackNaked000.png"))
	graphics.drawImage(thisImage, 0, 0, null)
//get height and width of card
	def sampleImage = java.awt.Toolkit.getDefaultToolkit().getImage(
		"images/Bcards/"+DeckName+"/0.png")
	def oneWidth = sampleImage.getWidth()
	def oneHeight = sampleImage.getHeight()
//player card
	def x = 0
	def y = 0
	if(Dp>-1){
		if(Dp<52){
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/"+Dp+".png"))
		}else{
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/back.png"))
		}
		x = 10
		y = height-oneHeight-40
		graphics.drawImage(thisImage, (int)x, (int)y, null)
	}
//stack
	if(Ds>-1){
		if(Ds<52){
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/"+Ds+".png"))
		}else{
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/back.png"))
		}
		x = width/2-oneWidth/2
		y = height-oneHeight-70
		graphics.drawImage(thisImage, (int)x, (int)y, null)
	}
//bank card
	if(Db>-1){
		if(Db<52){
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/"+Db+".png"))
		}else{
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/back.png"))
		}
		x = width-10-oneWidth
		y = height-oneHeight-40
		graphics.drawImage(thisImage, (int)x, (int)y, null)
	}
	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(image, "png", baos)
	setImage(baos.toByteArray(),0)
}

def getScore = {card -> //------------------------------------------------------------------
	def s
	if(card<52) s = (int)Math.ceil((card+1)/4)
	else s = (int)Math.ceil((card-51)/4)
	return s
}

Penalty = {s ->//---------------------------------------------------------------------------
	def st = ["", "four cards", "", "", "", "", "", "", "", "", "", 
		"one card", "two cards", "three cards"]
	def sn = [0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 3]
	def p = true
	if(!Paid){
		Player = !Player
		if(Player){
			show(Title+"Penalty of "+st[s]+" for the "+(Player?"player":"bank"))
			showButton("OK")
			p = true
		}else{
			show(Title+"Penalty of "+st[s]+" for the "+(Player?"player":"bank"))
			wait(2.0)
			p = true
		}
		if(p){
			def j = 0
			while(j<sn[s]){
				if(Player){
					showCards(Cp[Mp]-52, Cs[Ms]-52, Cb[Mb])
					wait(0.3)
					Ms++
					Cs[Ms] = Cp[Mp]
					if(Mp<Np-1){
						Mp++
						showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
					}else{
						showCards(-1, Cs[Ms]-52, Cb[Mb])
						Play = false
						return
					}
					showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
					wait(0.6)
					if(getScore(Cs[Ms])==1||getScore(Cs[Ms])>10){Penalty(getScore(Cs[Ms]))}
					if(Paid)return 
				}else{
					showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb]-52)
					wait(0.3)
					Ms++
					Cs[Ms] = Cb[Mb]
					if(Mb<Nb-1){
						Mb++
						showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
					}else{
						showCards(Cp[Mp], Cs[Ms]-52, -1)
						Play = false
						return
					}
					showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
					wait(0.6)
					if(getScore(Cs[Ms])==1||getScore(Cs[Ms])>10){Penalty(getScore(Cs[Ms]))}
					if(Paid)return 
				}
				j++
			}
			show(Title+(Player?"Bank":"Player")+" wins "+(Ms+1)+" cards")
			wait(2.0)
			for(def k=0; k<Np-Mp; k++){Cp[k]=Cp[k+Mp]}
			for(def k=Np-Mp; k<53; k++){Cp[k]=-1}
			Np = Np-Mp
			for(def k=0; k<Nb-Mb; k++){Cb[k]=Cb[k+Mb]}
			for(def k=Nb-Mb; k<52; k++){Cb[k]=-1}
			Nb = Nb-Mb
			if(Player){
				for(def k=0; k<Ms+1; k++){Cb[k+Nb]=Cs[k]}
				Nb = Nb+Ms+1
			}else{
				for(def k=0; k<Ms+1; k++){Cp[k+Np]=Cs[k]}
				Np = Np+Ms+1
			}
			Mp = 0
			Mb = 0
			Ms = -1
			Cs = []
			Paid = true
			NoStack = true
			return 
		}else{
			show(Title)
			Paid = true
		}
	}
}

def StripJackNaked = {//main game-----------------------------------------------------------
	Paid = false
	if(Player){
		if(NoStack){
			showCards(Cp[Mp]-52, -1, Cb[Mb])
			NoStack = false
		}else{
			showCards(Cp[Mp]-52, Cs[Ms]-52, Cb[Mb])
		}
		wait(0.3)
		Ms++
		Cs[Ms] = Cp[Mp]
		if(Mp<Np-1){
			Mp++
			showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
		}else{
			showCards(-1, Cs[Ms]-52, Cb[Mb])
			Play = false
		}
		wait(0.6)
		if(getScore(Cs[Ms])==1||getScore(Cs[Ms])>10)Penalty(getScore(Cs[Ms]))
	}else{
		if(NoStack){
			showCards(Cp[Mp], -1, Cb[Mb]-52)
			NoStack = false
		}else{
			showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb]-52)
		}
		wait(0.3)
		Ms++
		Cs[Ms] = Cb[Mb]
		if(Mb<Nb-1){
			Mb++
			showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
		}else{
			showCards(Cp[Mp], Cs[Ms]-52, -1)
			Play = false
		}
		wait(0.6)
		if(getScore(Cs[Ms])==1||getScore(Cs[Ms])>10)Penalty(getScore(Cs[Ms]))
	}
	Player = !Player
}

//Start#####################################################################################

def EndGame = false
while(!EndGame){
	setImage(null)
	switch(getSelectedValue(Title+"This is a game of Strip Jack Naked or "+
		"Beggar-my-neighbour, just you against the bank.", 
		["play", "rules", "settings", "end"])){
	case 0://play
		SuffleDeal()
		Mp = 0
		Mb = 0
		Ms = -1
		NoStack = true
		Player = false
		Play = true
		while(Play){
			StripJackNaked()
		}
		if(Np<Nb){
			show(Title+"Bank wins")
			showButton("OK")
		}else{
			show(Title+"Player wins")
			showButton("OK")
		}
		break
	case 1://rules
		ShowRules()
		break
	case 2:
		ChooseDeck()
		break
	case 3:
		setImage(null)
		show(null)
		EndGame = true
		wait(2)
	}
}
// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
/*
 * Resources
 * scripts/BeggarMyNeighbour.groovy
 * images/StripJackNaked/*.jpg
 * images/StripJackNaked/*.png
 * images/Bcards/StandardDeck1/*.png
 */
